//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using System.Linq;
using Tecan.Sila2;
using Tecan.Sila2.Client;
using Tecan.Sila2.Server;

namespace Tecan.Sila2.Authorization.AuthorizationProviderService
{
    
    
    /// <summary>
    /// Class that implements the IAuthorizationProviderService interface through SiLA2
    /// </summary>
    public partial class AuthorizationProviderServiceClient : IAuthorizationProviderService
    {
        
        private IClientExecutionManager _executionManager;
        
        private IClientChannel _channel;
        
        private const string _serviceName = "sila2.org.silastandard.core.authorizationproviderservice.v1.AuthorizationProvider" +
            "Service";
        
        /// <summary>
        /// Creates a new instance
        /// </summary>
        /// <param name="channel">The channel through which calls should be executed</param>
        /// <param name="executionManager">A component to determine metadata to attach to any requests</param>
        public AuthorizationProviderServiceClient(IClientChannel channel, IClientExecutionManager executionManager)
        {
            _executionManager = executionManager;
            _channel = channel;
        }
        
        /// <summary>
        /// Verifies that a given token is valid for the requested server.
        /// </summary>
        /// <param name="accessToken">The token to be used along with accessing a Command or Property on a SiLA Server.</param>
        /// <param name="requestedServer">The server for which an authorization is requested.</param>
        /// <param name="requestedFeature">The feature that is requested to access.</param>
        public virtual long Verify(string accessToken, string requestedServer, string requestedFeature)
        {
            VerifyRequestDto request = new VerifyRequestDto(accessToken, requestedServer, requestedFeature, null);
            request.Validate();
            Tecan.Sila2.Client.IClientCallInfo callInfo = _executionManager.CreateCallOptions("org.silastandard/core/AuthorizationProviderService/v1/Command/Verify");
            try
            {
                long response = _channel.ExecuteUnobservableCommand<VerifyRequestDto, VerifyResponseDto>(_serviceName, "Verify", request, callInfo).TokenLifetime.Extract(_executionManager.DownloadBinaryStore);
                callInfo.FinishSuccessful();
                return response;
            } catch (System.Exception ex)
            {
                System.Exception exception = _channel.ConvertException(ex, ConvertVerifyException);
                callInfo.FinishWithErrors(exception);
                throw exception;
            }
        }
        
        /// <summary>
        /// Converts the error ocurred during execution of Verify to a proper exception
        /// </summary>
        /// <param name="errorIdentifier">The identifier of the error that has happened</param>
        /// <param name="errorMessage">The original error message from the server</param>
        /// <returns>The converted exception or null, if the error is not understood</returns>
        private static System.Exception ConvertVerifyException(string errorIdentifier, string errorMessage)
        {
            if ((errorIdentifier == "org.silastandard/core/AuthorizationProviderService/v1/DefinedExecutionError/Autho" +
                "rizationFailed"))
            {
                return new AuthorizationFailedException(errorMessage);
            }
            if ((errorIdentifier == "org.silastandard/core/AuthorizationProviderService/v1/DefinedExecutionError/Inval" +
                "idAccessToken"))
            {
                return new InvalidAccessTokenException(errorMessage);
            }
            return null;
        }
        
        private T Extract<T>(Tecan.Sila2.ISilaTransferObject<T> dto)
        
        {
            return dto.Extract(_executionManager.DownloadBinaryStore);
        }
    }
    
    /// <summary>
    /// Factory to instantiate clients for the Authorization Provider Service.
    /// </summary>
    [System.ComponentModel.Composition.ExportAttribute(typeof(IClientFactory))]
    [System.ComponentModel.Composition.PartCreationPolicyAttribute(System.ComponentModel.Composition.CreationPolicy.Shared)]
    public partial class AuthorizationProviderServiceClientFactory : IClientFactory
    {
        
        /// <summary>
        /// Gets the fully-qualified identifier of the feature for which clients can be generated
        /// </summary>
        public string FeatureIdentifier
        {
            get
            {
                return "org.silastandard/core/AuthorizationProviderService/v1";
            }
        }
        
        /// <summary>
        /// Gets the interface type for which clients can be generated
        /// </summary>
        public System.Type InterfaceType
        {
            get
            {
                return typeof(IAuthorizationProviderService);
            }
        }
        
        /// <summary>
        /// Creates a strongly typed client for the given execution channel and execution manager
        /// </summary>
        /// <param name="channel">The channel that should be used for communication with the server</param>
        /// <param name="executionManager">The execution manager to manage metadata</param>
        /// <returns>A strongly typed client. This object will be an instance of the InterfaceType property</returns>
        public object CreateClient(IClientChannel channel, IClientExecutionManager executionManager)
        {
            return new AuthorizationProviderServiceClient(channel, executionManager);
        }
    }
}

